#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>

#include <stdio.h>

#define TRUE	1
#define FALSE	0
#define MAX_COLORS 6

#define RED 	0
#define YELLOW	1
#define GREEN   2
#define BLUE    3
#define BLACK   4
#define WHITE   5

#define MAXX 800
#define MAXY 600
#define TOPY 30
#define BOTTOMY 550

#define BOMB struct BOMB_TYPE

BOMB {
	int stage;
	int x,y;
	int pause;
	int check;
	BOMB *next;
	BOMB *prev;
};

#define STA struct STA_TYPE

STA {
	int active;
	int sx, sy;
	int destx, desty;

	int xi, yi;
	int dx, dy, c, p, c1, c2;
	int c_x, c_y;

	STA *prev;
	STA *next;
};

#define MISSLE struct MISSLE_TYPE

MISSLE {
	int sx, sy;
	int destx, desty;
	int city;

	int alive;
	int sonofmirv;
	int depth;

	int xi, yi;
	int dx, dy, c, p, c1, c2;
	int c_x, c_y;

	int Mirved;

	int IsMirv;
	int MirvAtY;

	int NumMirvs;
	int mirv[3];
};

#define PLANE struct PLANE_TYPE

PLANE {

	int cx, cy;
	int active;
	int dropped;
	int flown;
	int dropat;

};

#define SMART struct SMART_TYPE

SMART {

	int sx, sy;
	int cx, cy;
	int destx, desty;

	int dx, dy;
	int xi, yi;
	int p, c1, c2, c;

	int good;
	int frame;
	int dest;

	SMART *next;
	SMART *prev;
};

extern Display *display;
extern int screen_num;
extern Window win;
extern int colors[MAX_COLORS];

int ErrorHandler();

extern void PlayGame();
